
#ifndef GP2021_H
#define GP2021_h

/* The following array is the index for gp2021 regs, which is
 * from the datasheet of gp2021 
 */
const unsigned char code gp2021_reg[] = {
	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,  /* CH0 Control          */
	0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,  /* CH1 Control          */
	0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,  /* CH2 Control          */
	0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,  /* CH3 Control          */
	0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,  /* CH4 Control          */
	0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,  /* CH5 Control          */ 
	0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,  /* CH6 Control          */
	0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,  /* CH7 Control          */
	0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,  /* CH8 Control          */
	0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,  /* CH9 Control          */
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,  /* CHa Control          */
	0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,  /* CHb Control          */
	0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,  /* MULTI Control        */
	0x69,                                     /* X_DCO_INCR_HIGH      */
	0x6b,                                     /* PROG_ACCUM_INT       */
	0x6d,                                     /* PROG_TIC_HIGH        */
	0x6f,                                     /* PROG_TIC_LOW         */
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,  /* ALL Control          */
	0x7b,                                     /* TIMEMARK_CONTROL     */
	0x7c,                                     /* TEST_CONTROL         */
	0x7d,                                     /* MULTI_CHANNEL_SELECT */
	0x7e,                                     /* SYSTEM_SETUP         */
	0x7f,                                     /* RESET_CONTROL        */
    0x80,0x81,0x82,0x83,                      /* Status Registers     */
	0x84,0x85,0x86,0x87,                      /* CH0 Accumulate       */
	0x88,0x89,0x8a,0x8b,                      /* CH1 Accumulate       */
	0x8c,0x8d,0x8e,0x8f,                      /* CH2 Accumulate       */
	0x90,0x91,0x92,0x93,                      /* CH3 Accumulate       */
	0x94,0x95,0x96,0x97,                      /* CH4 Accumulate       */
	0x98,0x99,0x9a,0x9b,                      /* CH5 Accumulate       */
	0x9c,0x9d,0x9e,0x9f,                      /* CH6 Accumulate       */
    0xa0,0xa1,0xa2,0xa3,                      /* CH7 Accumulate       */
	0xa4,0xa5,0xa6,0xa7,                      /* CH8 Accumulate       */
	0xa8,0xa9,0xaa,0xab,                      /* CH9 Accumulate       */
	0xac,0xad,0xae,0xaf,                      /* CH10Accumulate       */ 
    0xb0,0xb1,0xb2,0xb3,                      /* CH11Accumulate       */
	0xb4,0xb5,0xb6,0xb7,                      /* Multi Accumulate     */
	0xb8,0xb9,0xba,0xbb,                      /* ALL Accumulate       */
	0xe0,                                     /* WAIT_STATE           */
	0xe1,                                     /* SYSTEM_CONFIG        */
	0xe3,                                     /* SYSTEM_ERROR_STATUS  */
	0xe4,                                     /* DATA_RETENT          */
	0xf0,                                     /* IO_CONFIG            */
	0xf1,                                     /* TEST_CONFIG          */
	0xf2                                      /* DATA BUS TEST        */
	};
#define GP2021_REG_SIZE  sizeof(gp2021_reg)

/*  */

//	0xc0,                                     /* RTC_LS               */
//	0xc1,                                     /* RTC_2ND              */
//	0xc2,                                     /* RTC_MS               */
//	0xc3,                                     /* CLOCK_RESET          */
//	0xc4,                                     /* WATCHDOG_RESET       */
//	0xd0,                                     /* TX_DATA_A, RX_DATA_A */
//	0xd1,                                     /* TX_DATA_B, RX_DATA_B */
//	0xd2,                                     /* CONFIG_A, STATUS_A   */
//	0xd3,                                     /* CONFIG B, STATUS_B   */
//	0xd4,                                     /* CH10 Control         */
//	0xd5,                                     /* CH11 Control         */
//	0xd6,                                     /* MULTI Control        */
//	0xd7,                                     /* X_DCO_INCR_HIGH      */
//	0xe2,                                     /* Not Used             */

#endif
